using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;

namespace AdvancedCustomTreeViewLayout
{
    public partial class Window1 : System.Windows.Window
	{
        public static RoutedCommand MyDoubleClickCommand = new RoutedCommand("MyDoubleClickCommand", typeof(Window1));

        public Window1()
		{
			InitializeComponent();

            this.Loaded += new RoutedEventHandler(Window1_Loaded);

            tree.MouseDoubleClick += new MouseButtonEventHandler(tree_MouseDoubleClick);
        }

        void Window1_Loaded(object sender, RoutedEventArgs e)
        {
            XmlDataProvider provider = tree.TryFindResource("productsXml") as XmlDataProvider;
             
            if (provider != null)
            {
              XmlDocument xmlDocAppInfo = new XmlDocument();
              xmlDocAppInfo.Load("products.xml");
              provider.Document = xmlDocAppInfo;
            }
        }

        void tree_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            XmlElement selectedNode = (XmlElement)tree.SelectedItem;
            if (selectedNode.Name == "Document")
            {
                XmlNode productRegistryNode = selectedNode.ParentNode.ParentNode.PreviousSibling;

                // open the file
                //System.Diagnostics.Process proc = new System.Diagnostics.Process();
                //proc.StartInfo.FileName = productRegistryNode.InnerText + selectedNode.ChildNodes[2].InnerText;
                //MessageBox.Show(proc.StartInfo.FileName);
                //proc.StartInfo.UseShellExecute = true;
                //proc.StartInfo.ErrorDialog = false;
                //proc.Start();

                Microsoft.Office.Interop.Word.Application objWord;
                Microsoft.Office.Interop.Excel.Application objExcel;
                Microsoft.Office.Interop.Word.Document objWordDoc;
                Microsoft.Office.Interop.Excel.Workbook objExcelWB;
                string filename = productRegistryNode.InnerText + selectedNode.ChildNodes[2].InnerText;

                object objFileName = productRegistryNode.InnerText + selectedNode.ChildNodes[2].InnerText;
                object missing = Type.Missing;
                object nullobj = System.Reflection.Missing.Value;
                if (filename.Contains("dot"))
                {
                    objWord = new Microsoft.Office.Interop.Word.Application();
                    object falseValue = false;
                    object trueValue = true;
                    objWord.Visible = true;
                    objWord.Activate();
                    objWordDoc = objWord.Documents.Add(ref objFileName, ref nullobj, ref nullobj, ref trueValue);
                    objWordDoc.Activate();

                    objWordDoc.Application.Application.Visible = true;

                    //MessageBox.Show("Hit return to close Word");

                    //objWordDoc.Application.Documents.Close(ref missing, ref missing, ref missing);
                    //objWord.Quit(ref nullobj, ref nullobj, ref nullobj);

                    objWord = null;
                    objWordDoc = null;
                }
                else if (filename.Contains("xlt"))
                {
                    objExcel = new Microsoft.Office.Interop.Excel.Application();
                    objExcelWB = objExcel.Workbooks.Open(filename, missing, missing, missing, missing, missing, missing,
                missing, missing, missing, missing, missing, missing, missing, missing);
                    objExcelWB.Application.Visible = true;

                    objExcel = null;
                    objExcelWB = null;
                }
            }
        }

        public void setXMLDataFilename(string dataFile)
        {
            XmlDataProvider dp = tree.FindResource("productsXml") as XmlDataProvider;
            string temp = "file://" + dataFile;
            dp.Source = new Uri(temp);
        }
    }
}